/*----- PROTECTED REGION ID(Rfilk.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        Rfilk.cpp
//
// description : C++ source for the Rfilk class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Rfilk are implemented in this file.
//
//
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include "Rfilk.h"
#include "RfilkClass.h"
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	Rfilk.cpp

/**
 *  Rfilk class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name      |  Method name
//================================================================
//  State             |  Inherited (no method)
//  Status            |  Inherited (no method)
//  ResetArcDetector  |  reset_arc_detector
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  cavityFlow             |  Tango::DevBoolean	Scalar
//  coolingRack            |  Tango::DevBoolean	Scalar
//  dummyLoadFlow          |  Tango::DevBoolean	Scalar
//  circulatorPs           |  Tango::DevBoolean	Scalar
//  circulatorArc          |  Tango::DevBoolean	Scalar
//  circulatorLowTemp      |  Tango::DevBoolean	Scalar
//  circulatorHighTemp     |  Tango::DevBoolean	Scalar
//  vacuumFeedthroughFlow  |  Tango::DevBoolean	Scalar
//================================================================

namespace Rfilk_ns
{
/*----- PROTECTED REGION ID(Rfilk::namespace_starting) ENABLED START -----*/
/* clang-format on */
//	static initializations
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	Rfilk::namespace_starting

//--------------------------------------------------------
/**
 *	Method     : Rfilk::Rfilk()
 *	Description: Constructors for a Tango device
 *                implementing the classRfilk
 */
//--------------------------------------------------------
Rfilk::Rfilk(Tango::DeviceClass *cl, std::string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Rfilk::constructor_1) ENABLED START -----*/
	/* clang-format on */
	init_device();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::constructor_1
}
//--------------------------------------------------------
Rfilk::Rfilk(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(Rfilk::constructor_2) ENABLED START -----*/
	/* clang-format on */
	init_device();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::constructor_2
}
//--------------------------------------------------------
Rfilk::Rfilk(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(Rfilk::constructor_3) ENABLED START -----*/
	/* clang-format on */
	init_device();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::constructor_3
}
//--------------------------------------------------------
Rfilk::~Rfilk()
{
	delete_device();
}

//--------------------------------------------------------
/**
 *	Method     : Rfilk::delete_device()
 *	Description: will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Rfilk::delete_device()
{
	DEBUG_STREAM << "Rfilk::delete_device() " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Rfilk::delete_device) ENABLED START -----*/
	/* clang-format on */
	//	Delete device allocated objects
	if (cavityFlowDIO)
		delete cavityFlowDIO;
	if (coolingRackDIO)
		delete coolingRackDIO;
	if (dummyLoadFlowDIO)
		delete dummyLoadFlowDIO;
	if (circulatorPsDIO)
		delete circulatorPsDIO;
	if (circulatorArcDIO)
		delete circulatorArcDIO;
	if (circulatorLowTempDIO)
		delete circulatorLowTempDIO;
	if (circulatorHighTempDIO)
		delete circulatorHighTempDIO;
	if (vacuumFeedthroughFlowDIO)
		delete vacuumFeedthroughFlowDIO;
	if (resetArcDetectorDIO)
		delete resetArcDetectorDIO;
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::delete_device
	delete[] attr_cavityFlow_read;
	delete[] attr_coolingRack_read;
	delete[] attr_dummyLoadFlow_read;
	delete[] attr_circulatorPs_read;
	delete[] attr_circulatorArc_read;
	delete[] attr_circulatorLowTemp_read;
	delete[] attr_circulatorHighTemp_read;
	delete[] attr_vacuumFeedthroughFlow_read;
}

//--------------------------------------------------------
/**
 *	Method     : Rfilk::init_device()
 *	Description: will be called at device initialization.
 */
//--------------------------------------------------------
void Rfilk::init_device()
{
	DEBUG_STREAM << "Rfilk::init_device() create device " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Rfilk::init_device_before) ENABLED START -----*/
	/* clang-format on */
	//	Initialization before get_device_property() call
	initError.clear();
	cavityFlowDIO = coolingRackDIO = dummyLoadFlowDIO = circulatorPsDIO =
	    circulatorArcDIO = circulatorLowTempDIO =
	    circulatorHighTempDIO = vacuumFeedthroughFlowDIO = 
	    resetArcDetectorDIO = NULL;
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::init_device_before


	//	Get the device properties from database
	get_device_property();

	attr_cavityFlow_read = new Tango::DevBoolean[1];
	attr_coolingRack_read = new Tango::DevBoolean[1];
	attr_dummyLoadFlow_read = new Tango::DevBoolean[1];
	attr_circulatorPs_read = new Tango::DevBoolean[1];
	attr_circulatorArc_read = new Tango::DevBoolean[1];
	attr_circulatorLowTemp_read = new Tango::DevBoolean[1];
	attr_circulatorHighTemp_read = new Tango::DevBoolean[1];
	attr_vacuumFeedthroughFlow_read = new Tango::DevBoolean[1];
	//	No longer if mandatory property not set.
	if (mandatoryNotDefined)
		return;

	/*----- PROTECTED REGION ID(Rfilk::init_device) ENABLED START -----*/
	/* clang-format on */
	//	Initialize device
	try {
		cavityFlowDIO = new DIO(cavityFlowDevice);
		coolingRackDIO = new DIO(coolingRackDevice);
		dummyLoadFlowDIO = new DIO(dummyLoadFlowDevice);
		circulatorPsDIO = new DIO(circulatorPsDevice);
		circulatorArcDIO = new DIO(circulatorArcDevice);
		circulatorLowTempDIO = new DIO(circulatorLowTempDevice);
		circulatorHighTempDIO = new DIO(circulatorHighTempDevice);
		vacuumFeedthroughFlowDIO = new DIO(vacuumFeedthroughFlowDevice);
		resetArcDetectorDIO = new DIO(resetArcDetectorDevice);
	
		check_state();
	} catch (Tango::DevFailed &e) {
		initError = "initialization failed: " + string(e.errors[0].desc);
	} catch (...) {
		initError = "initialization failed: unknown error";
	}

	if (! initError.empty()) {
		ERROR_STREAM << initError << endl;
		set_state(Tango::UNKNOWN);
		set_status(initError);
		assert(false);
	} else {
		set_state(Tango::ON);
	}

	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::init_device
}

//--------------------------------------------------------
/**
 *	Method     : Rfilk::get_device_property()
 *	Description: Read database to initialize property data members.
 */
//--------------------------------------------------------
void Rfilk::get_device_property()
{
	/*----- PROTECTED REGION ID(Rfilk::get_device_property_before) ENABLED START -----*/
	/* clang-format on */
	//	Initialize property data members
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::get_device_property_before

	mandatoryNotDefined = false;

	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("CavityFlowDevice"));
	dev_prop.push_back(Tango::DbDatum("CoolingRackDevice"));
	dev_prop.push_back(Tango::DbDatum("DummyLoadFlowDevice"));
	dev_prop.push_back(Tango::DbDatum("CirculatorPsDevice"));
	dev_prop.push_back(Tango::DbDatum("CirculatorArcDevice"));
	dev_prop.push_back(Tango::DbDatum("CirculatorLowTempDevice"));
	dev_prop.push_back(Tango::DbDatum("CirculatorHighTempDevice"));
	dev_prop.push_back(Tango::DbDatum("VacuumFeedthroughFlowDevice"));
	dev_prop.push_back(Tango::DbDatum("ResetArcDetectorDevice"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);

		//	get instance on RfilkClass to get class property
		Tango::DbDatum	def_prop, cl_prop;
		RfilkClass	*ds_class =
			(static_cast<RfilkClass *>(get_device_class()));
		int	i = -1;

		//	Try to initialize CavityFlowDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  cavityFlowDevice;
		else {
			//	Try to initialize CavityFlowDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  cavityFlowDevice;
		}
		//	And try to extract CavityFlowDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  cavityFlowDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize CoolingRackDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  coolingRackDevice;
		else {
			//	Try to initialize CoolingRackDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  coolingRackDevice;
		}
		//	And try to extract CoolingRackDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  coolingRackDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize DummyLoadFlowDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  dummyLoadFlowDevice;
		else {
			//	Try to initialize DummyLoadFlowDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  dummyLoadFlowDevice;
		}
		//	And try to extract DummyLoadFlowDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  dummyLoadFlowDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize CirculatorPsDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  circulatorPsDevice;
		else {
			//	Try to initialize CirculatorPsDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  circulatorPsDevice;
		}
		//	And try to extract CirculatorPsDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  circulatorPsDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize CirculatorArcDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  circulatorArcDevice;
		else {
			//	Try to initialize CirculatorArcDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  circulatorArcDevice;
		}
		//	And try to extract CirculatorArcDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  circulatorArcDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize CirculatorLowTempDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  circulatorLowTempDevice;
		else {
			//	Try to initialize CirculatorLowTempDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  circulatorLowTempDevice;
		}
		//	And try to extract CirculatorLowTempDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  circulatorLowTempDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize CirculatorHighTempDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  circulatorHighTempDevice;
		else {
			//	Try to initialize CirculatorHighTempDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  circulatorHighTempDevice;
		}
		//	And try to extract CirculatorHighTempDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  circulatorHighTempDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize VacuumFeedthroughFlowDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  vacuumFeedthroughFlowDevice;
		else {
			//	Try to initialize VacuumFeedthroughFlowDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  vacuumFeedthroughFlowDevice;
		}
		//	And try to extract VacuumFeedthroughFlowDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  vacuumFeedthroughFlowDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

		//	Try to initialize ResetArcDetectorDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  resetArcDetectorDevice;
		else {
			//	Try to initialize ResetArcDetectorDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  resetArcDetectorDevice;
		}
		//	And try to extract ResetArcDetectorDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  resetArcDetectorDevice;
		//	Property StartDsPath is mandatory, check if has been defined in database.
		check_mandatory_property(cl_prop, dev_prop[i]);

	}

	/*----- PROTECTED REGION ID(Rfilk::get_device_property_after) ENABLED START -----*/
	/* clang-format on */
	//	Check device property data members init
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::get_device_property_after
}
//--------------------------------------------------------
/**
 *	Method     : Rfilk::check_mandatory_property()
 *	Description: For mandatory properties check if defined in database.
 */
//--------------------------------------------------------
void Rfilk::check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop)
{
	//	Check if all properties are empty
	if (class_prop.is_empty() && dev_prop.is_empty())
	{
		TangoSys_OMemStream	tms;
		tms << std::endl <<"Property \'" << dev_prop.name;
		if (Tango::Util::instance()->_UseDb==true)
			tms << "\' is mandatory but not defined in database";
		else
			tms << "\' is mandatory but cannot be defined without database";
		append_status(tms.str());
		mandatoryNotDefined = true;
		/*----- PROTECTED REGION ID(Rfilk::check_mandatory_property) ENABLED START -----*/
		/* clang-format on */
		std::cerr << tms.str() << " for " << device_name << std::endl;
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	Rfilk::check_mandatory_property
	}
}


//--------------------------------------------------------
/**
 *	Method     : Rfilk::always_executed_hook()
 *	Description: method always executed before any command is executed
 */
//--------------------------------------------------------
void Rfilk::always_executed_hook()
{
	DEBUG_STREAM << "Rfilk::always_executed_hook()  " << device_name << std::endl;
	if (mandatoryNotDefined)
	{
		Tango::Except::throw_exception(
					(const char *)"PROPERTY_NOT_SET",
					get_status().c_str(),
					(const char *)"Rfilk::always_executed_hook()");
	}
	/*----- PROTECTED REGION ID(Rfilk::always_executed_hook) ENABLED START -----*/
	/* clang-format on */
	//	code always executed before all requests
	if (! initError.empty()) {
		ERROR_STREAM << initError << endl;
		set_status(initError);
		set_state(Tango::UNKNOWN);
		assert(false);
		return;
	}

	try {
		check_state();
	} catch(Tango::DevFailed &e) {
		ERROR_STREAM << string(e.errors[0].desc) << endl;
		set_state(Tango::UNKNOWN);
		set_status(string(e.errors[0].desc));
		assert(false);
	}

	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method     : Rfilk::read_attr_hardware()
 *	Description: Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Rfilk::read_attr_hardware(TANGO_UNUSED(std::vector<long> &attr_list))
{
	DEBUG_STREAM << "Rfilk::read_attr_hardware(std::vector<long> &attr_list) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Rfilk::read_attr_hardware) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	check_init();
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::read_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute cavityFlow related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Rfilk::read_cavityFlow(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Rfilk::read_cavityFlow(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Rfilk::read_cavityFlow) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr_cavityFlow_read[0] = cavityFlowDIO->read();
	attr.set_value(attr_cavityFlow_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::read_cavityFlow
}
//--------------------------------------------------------
/**
 *	Read attribute coolingRack related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Rfilk::read_coolingRack(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Rfilk::read_coolingRack(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Rfilk::read_coolingRack) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr_coolingRack_read[0] = coolingRackDIO->read();
	attr.set_value(attr_coolingRack_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::read_coolingRack
}
//--------------------------------------------------------
/**
 *	Read attribute dummyLoadFlow related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Rfilk::read_dummyLoadFlow(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Rfilk::read_dummyLoadFlow(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Rfilk::read_dummyLoadFlow) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr_dummyLoadFlow_read[0] = dummyLoadFlowDIO->read();
	attr.set_value(attr_dummyLoadFlow_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::read_dummyLoadFlow
}
//--------------------------------------------------------
/**
 *	Read attribute circulatorPs related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Rfilk::read_circulatorPs(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Rfilk::read_circulatorPs(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Rfilk::read_circulatorPs) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr_circulatorPs_read[0] = circulatorPsDIO->read();
	attr.set_value(attr_circulatorPs_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::read_circulatorPs
}
//--------------------------------------------------------
/**
 *	Read attribute circulatorArc related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Rfilk::read_circulatorArc(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Rfilk::read_circulatorArc(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Rfilk::read_circulatorArc) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr_circulatorArc_read[0] = circulatorArcDIO->read();
	attr.set_value(attr_circulatorArc_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::read_circulatorArc
}
//--------------------------------------------------------
/**
 *	Read attribute circulatorLowTemp related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Rfilk::read_circulatorLowTemp(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Rfilk::read_circulatorLowTemp(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Rfilk::read_circulatorLowTemp) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr_circulatorLowTemp_read[0] = circulatorLowTempDIO->read();
	attr.set_value(attr_circulatorLowTemp_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::read_circulatorLowTemp
}
//--------------------------------------------------------
/**
 *	Read attribute circulatorHighTemp related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Rfilk::read_circulatorHighTemp(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Rfilk::read_circulatorHighTemp(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Rfilk::read_circulatorHighTemp) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr_circulatorHighTemp_read[0] = circulatorHighTempDIO->read();
	attr.set_value(attr_circulatorHighTemp_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::read_circulatorHighTemp
}
//--------------------------------------------------------
/**
 *	Read attribute vacuumFeedthroughFlow related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Rfilk::read_vacuumFeedthroughFlow(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Rfilk::read_vacuumFeedthroughFlow(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Rfilk::read_vacuumFeedthroughFlow) ENABLED START -----*/
	/* clang-format on */
	//	Set the attribute value
	attr_vacuumFeedthroughFlow_read[0] = vacuumFeedthroughFlowDIO->read();
	attr.set_value(attr_vacuumFeedthroughFlow_read);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::read_vacuumFeedthroughFlow
}

//--------------------------------------------------------
/**
 *	Method     : Rfilk::add_dynamic_attributes()
 *	Description: Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Rfilk::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Rfilk::add_dynamic_attributes) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code to create and add dynamic attributes if any
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command ResetArcDetector related method
 *	Description: Reset Arc Detector
 *
 */
//--------------------------------------------------------
void Rfilk::reset_arc_detector()
{
	DEBUG_STREAM << "Rfilk::ResetArcDetector()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Rfilk::reset_arc_detector) ENABLED START -----*/
	/* clang-format on */

	//	Add your own code
	check_init();
	resetArcDetectorDIO->pulse(100);
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::reset_arc_detector
}
//--------------------------------------------------------
/**
 *	Method     : Rfilk::add_dynamic_commands()
 *	Description: Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void Rfilk::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(Rfilk::add_dynamic_commands) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code to create and add dynamic commands if any
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::add_dynamic_commands
}

/*----- PROTECTED REGION ID(Rfilk::namespace_ending) ENABLED START -----*/
/* clang-format on */
//	Additional Methods
void Rfilk::check_init()
{
	if (! initError.empty())
		Tango::Except::throw_exception( "",
				initError.c_str(),
				"Rfilk::check_init()");
}

void Rfilk::check_state()
{
}

/*----- PROTECTED REGION END -----*/	//	Rfilk::namespace_ending
} //	namespace
