/*----- PROTECTED REGION ID(Rfilk.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        Rfilk.h
//
// description : Include file for the Rfilk class
//
//
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Rfilk_H
#define Rfilk_H

#include <tango.h>

#include "dio.h"
#include "adc.h"
#include "dac.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	Rfilk.h

#ifdef TANGO_LOG
	// cppTango after c934adea (Merge branch 'remove-cout-definition' into 'main', 2022-05-23)
	// nothing to do
#else
	// cppTango 9.3-backports and older
	#define TANGO_LOG       cout
	#define TANGO_LOG_INFO  cout2
	#define TANGO_LOG_DEBUG cout3
#endif // TANGO_LOG

/**
 *  Rfilk class description:
 *    
 */


namespace Rfilk_ns
{
/*----- PROTECTED REGION ID(Rfilk::Additional Class Declarations) ENABLED START -----*/
/* clang-format on */
//	Additional Class Declarations
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	Rfilk::Additional Class Declarations

class Rfilk : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(Rfilk::Data Members) ENABLED START -----*/
/* clang-format on */
//	Add your own data members
	string initError;
	DIO *cavityFlowDIO, *coolingRackDIO, *dummyLoadFlowDIO, *circulatorPsDIO,
	    *circulatorArcDIO, *circulatorLowTempDIO, 
	    *circulatorHighTempDIO, *vacuumFeedthroughFlowDIO, *resetArcDetectorDIO;
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	Rfilk::Data Members

//	Device property data members
public:
	//	CavityFlowDevice:	
	std::string	cavityFlowDevice;
	//	CoolingRackDevice:	
	std::string	coolingRackDevice;
	//	DummyLoadFlowDevice:	
	std::string	dummyLoadFlowDevice;
	//	CirculatorPsDevice:	
	std::string	circulatorPsDevice;
	//	CirculatorArcDevice:	
	std::string	circulatorArcDevice;
	//	CirculatorLowTempDevice:	
	std::string	circulatorLowTempDevice;
	//	CirculatorHighTempDevice:	
	std::string	circulatorHighTempDevice;
	//	VacuumFeedthroughFlowDevice:	
	std::string	vacuumFeedthroughFlowDevice;
	//	ResetArcDetectorDevice:	
	std::string	resetArcDetectorDevice;

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevBoolean	*attr_cavityFlow_read;
	Tango::DevBoolean	*attr_coolingRack_read;
	Tango::DevBoolean	*attr_dummyLoadFlow_read;
	Tango::DevBoolean	*attr_circulatorPs_read;
	Tango::DevBoolean	*attr_circulatorArc_read;
	Tango::DevBoolean	*attr_circulatorLowTemp_read;
	Tango::DevBoolean	*attr_circulatorHighTemp_read;
	Tango::DevBoolean	*attr_vacuumFeedthroughFlow_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Rfilk(Tango::DeviceClass *cl,std::string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Rfilk(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Rfilk(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Rfilk();


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method     : Rfilk::read_attr_hardware()
	 *	Description: Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(std::vector<long> &attr_list);

/**
 *	Attribute cavityFlow related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_cavityFlow(Tango::Attribute &attr);
	virtual bool is_cavityFlow_allowed(Tango::AttReqType type);
/**
 *	Attribute coolingRack related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_coolingRack(Tango::Attribute &attr);
	virtual bool is_coolingRack_allowed(Tango::AttReqType type);
/**
 *	Attribute dummyLoadFlow related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_dummyLoadFlow(Tango::Attribute &attr);
	virtual bool is_dummyLoadFlow_allowed(Tango::AttReqType type);
/**
 *	Attribute circulatorPs related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_circulatorPs(Tango::Attribute &attr);
	virtual bool is_circulatorPs_allowed(Tango::AttReqType type);
/**
 *	Attribute circulatorArc related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_circulatorArc(Tango::Attribute &attr);
	virtual bool is_circulatorArc_allowed(Tango::AttReqType type);
/**
 *	Attribute circulatorLowTemp related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_circulatorLowTemp(Tango::Attribute &attr);
	virtual bool is_circulatorLowTemp_allowed(Tango::AttReqType type);
/**
 *	Attribute circulatorHighTemp related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_circulatorHighTemp(Tango::Attribute &attr);
	virtual bool is_circulatorHighTemp_allowed(Tango::AttReqType type);
/**
 *	Attribute vacuumFeedthroughFlow related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_vacuumFeedthroughFlow(Tango::Attribute &attr);
	virtual bool is_vacuumFeedthroughFlow_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method     : Rfilk::add_dynamic_attributes()
	 *	Description: Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command ResetArcDetector related method
	 *	Description: Reset Arc Detector
	 *
	 */
	virtual void reset_arc_detector();
	virtual bool is_ResetArcDetector_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method     : Rfilk::add_dynamic_commands()
	 *	Description: Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Rfilk::Additional Method prototypes) ENABLED START -----*/
/* clang-format on */
//	Additional Method prototypes
	void check_init();
	void check_state();
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	Rfilk::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Rfilk::Additional Classes Definitions) ENABLED START -----*/
/* clang-format on */
//	Additional Classes Definitions
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	Rfilk::Additional Classes Definitions

}	//	End of namespace

#endif   //	Rfilk_H
