/*----- PROTECTED REGION ID(RfilkClass.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        RfilkClass.cpp
//
// description : C++ source for the RfilkClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the Rfilk once per process.
//
//
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include "RfilkClass.h"
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfilkClass.cpp

//-------------------------------------------------------------------
/**
 *	Create RfilkClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Rfilk_class(const char *name) {
		return Rfilk_ns::RfilkClass::init(name);
	}
}

namespace Rfilk_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
RfilkClass *RfilkClass::_instance = NULL;

//===================================================================
//	Class constants
//===================================================================
//--------------------------------------------------------
/**
 * method : 		RfilkClass::RfilkClass(std::string &s)
 * description : 	constructor for the RfilkClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
RfilkClass::RfilkClass(std::string &s):Tango::DeviceClass(s)
{
	TANGO_LOG_INFO << "Entering RfilkClass constructor" << std::endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(RfilkClass::constructor) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfilkClass::constructor

	TANGO_LOG_INFO << "Leaving RfilkClass constructor" << std::endl;
}

//--------------------------------------------------------
/**
 * method : 		RfilkClass::~RfilkClass()
 * description : 	destructor for the RfilkClass
 */
//--------------------------------------------------------
RfilkClass::~RfilkClass()
{
	/*----- PROTECTED REGION ID(RfilkClass::destructor) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfilkClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		RfilkClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
RfilkClass *RfilkClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			std::string s(name);
			_instance = new RfilkClass(s);
		}
		catch (std::bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		RfilkClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
RfilkClass *RfilkClass::instance()
{
	if (_instance == NULL)
	{
		std::cerr << "Class is not initialized !!" << std::endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		ResetArcDetectorClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetArcDetectorClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	TANGO_LOG_INFO << "ResetArcDetectorClass::execute(): arrived" << std::endl;
	((static_cast<Rfilk *>(device))->reset_arc_detector());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method     : RfilkClass::get_class_property()
 *	Description: Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum RfilkClass::get_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : RfilkClass::get_default_device_property()
 *	Description: Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum RfilkClass::get_default_device_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : RfilkClass::get_default_class_property()
 *	Description: Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum RfilkClass::get_default_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method     : RfilkClass::set_default_property()
 *	Description: Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void RfilkClass::set_default_property()
{
	std::string	prop_name;
	std::string	prop_desc;
	std::string	prop_def;
	std::vector<std::string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "CavityFlowDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CoolingRackDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "DummyLoadFlowDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CirculatorPsDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CirculatorArcDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CirculatorLowTempDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "CirculatorHighTempDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "VacuumFeedthroughFlowDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "ResetArcDetectorDevice";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method     : RfilkClass::write_class_property()
 *	Description: Set class description fields as property in database
 */
//--------------------------------------------------------
void RfilkClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	std::string	classname = get_name();
	std::string	header;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	std::string	str_title("");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	std::vector<std::string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	std::vector<std::string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method     : RfilkClass::device_factory()
 *	Description: Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void RfilkClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(RfilkClass::device_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfilkClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		TANGO_LOG_DEBUG << "Device name : " << (*devlist_ptr)[i].in() << std::endl;
		device_list.push_back(new Rfilk(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Rfilk *dev = static_cast<Rfilk *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(RfilkClass::device_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfilkClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : RfilkClass::attribute_factory()
 *	Description: Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void RfilkClass::attribute_factory(std::vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(RfilkClass::attribute_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfilkClass::attribute_factory_before
	//	Attribute : cavityFlow
	cavityFlowAttrib	*cavityflow = new cavityFlowAttrib();
	Tango::UserDefaultAttrProp	cavityflow_prop;
	//	description	not set for cavityFlow
	//	label	not set for cavityFlow
	//	unit	not set for cavityFlow
	//	standard_unit	not set for cavityFlow
	//	display_unit	not set for cavityFlow
	//	format	not set for cavityFlow
	//	max_value	not set for cavityFlow
	//	min_value	not set for cavityFlow
	//	max_alarm	not set for cavityFlow
	//	min_alarm	not set for cavityFlow
	//	max_warning	not set for cavityFlow
	//	min_warning	not set for cavityFlow
	//	delta_t	not set for cavityFlow
	//	delta_val	not set for cavityFlow
	cavityflow->set_default_properties(cavityflow_prop);
	//	Not Polled
	cavityflow->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(cavityflow);

	//	Attribute : coolingRack
	coolingRackAttrib	*coolingrack = new coolingRackAttrib();
	Tango::UserDefaultAttrProp	coolingrack_prop;
	//	description	not set for coolingRack
	//	label	not set for coolingRack
	//	unit	not set for coolingRack
	//	standard_unit	not set for coolingRack
	//	display_unit	not set for coolingRack
	//	format	not set for coolingRack
	//	max_value	not set for coolingRack
	//	min_value	not set for coolingRack
	//	max_alarm	not set for coolingRack
	//	min_alarm	not set for coolingRack
	//	max_warning	not set for coolingRack
	//	min_warning	not set for coolingRack
	//	delta_t	not set for coolingRack
	//	delta_val	not set for coolingRack
	coolingrack->set_default_properties(coolingrack_prop);
	//	Not Polled
	coolingrack->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(coolingrack);

	//	Attribute : dummyLoadFlow
	dummyLoadFlowAttrib	*dummyloadflow = new dummyLoadFlowAttrib();
	Tango::UserDefaultAttrProp	dummyloadflow_prop;
	//	description	not set for dummyLoadFlow
	//	label	not set for dummyLoadFlow
	//	unit	not set for dummyLoadFlow
	//	standard_unit	not set for dummyLoadFlow
	//	display_unit	not set for dummyLoadFlow
	//	format	not set for dummyLoadFlow
	//	max_value	not set for dummyLoadFlow
	//	min_value	not set for dummyLoadFlow
	//	max_alarm	not set for dummyLoadFlow
	//	min_alarm	not set for dummyLoadFlow
	//	max_warning	not set for dummyLoadFlow
	//	min_warning	not set for dummyLoadFlow
	//	delta_t	not set for dummyLoadFlow
	//	delta_val	not set for dummyLoadFlow
	dummyloadflow->set_default_properties(dummyloadflow_prop);
	//	Not Polled
	dummyloadflow->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(dummyloadflow);

	//	Attribute : circulatorPs
	circulatorPsAttrib	*circulatorps = new circulatorPsAttrib();
	Tango::UserDefaultAttrProp	circulatorps_prop;
	//	description	not set for circulatorPs
	//	label	not set for circulatorPs
	//	unit	not set for circulatorPs
	//	standard_unit	not set for circulatorPs
	//	display_unit	not set for circulatorPs
	//	format	not set for circulatorPs
	//	max_value	not set for circulatorPs
	//	min_value	not set for circulatorPs
	//	max_alarm	not set for circulatorPs
	//	min_alarm	not set for circulatorPs
	//	max_warning	not set for circulatorPs
	//	min_warning	not set for circulatorPs
	//	delta_t	not set for circulatorPs
	//	delta_val	not set for circulatorPs
	circulatorps->set_default_properties(circulatorps_prop);
	//	Not Polled
	circulatorps->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(circulatorps);

	//	Attribute : circulatorArc
	circulatorArcAttrib	*circulatorarc = new circulatorArcAttrib();
	Tango::UserDefaultAttrProp	circulatorarc_prop;
	//	description	not set for circulatorArc
	//	label	not set for circulatorArc
	//	unit	not set for circulatorArc
	//	standard_unit	not set for circulatorArc
	//	display_unit	not set for circulatorArc
	//	format	not set for circulatorArc
	//	max_value	not set for circulatorArc
	//	min_value	not set for circulatorArc
	//	max_alarm	not set for circulatorArc
	//	min_alarm	not set for circulatorArc
	//	max_warning	not set for circulatorArc
	//	min_warning	not set for circulatorArc
	//	delta_t	not set for circulatorArc
	//	delta_val	not set for circulatorArc
	circulatorarc->set_default_properties(circulatorarc_prop);
	//	Not Polled
	circulatorarc->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(circulatorarc);

	//	Attribute : circulatorLowTemp
	circulatorLowTempAttrib	*circulatorlowtemp = new circulatorLowTempAttrib();
	Tango::UserDefaultAttrProp	circulatorlowtemp_prop;
	//	description	not set for circulatorLowTemp
	//	label	not set for circulatorLowTemp
	//	unit	not set for circulatorLowTemp
	//	standard_unit	not set for circulatorLowTemp
	//	display_unit	not set for circulatorLowTemp
	//	format	not set for circulatorLowTemp
	//	max_value	not set for circulatorLowTemp
	//	min_value	not set for circulatorLowTemp
	//	max_alarm	not set for circulatorLowTemp
	//	min_alarm	not set for circulatorLowTemp
	//	max_warning	not set for circulatorLowTemp
	//	min_warning	not set for circulatorLowTemp
	//	delta_t	not set for circulatorLowTemp
	//	delta_val	not set for circulatorLowTemp
	circulatorlowtemp->set_default_properties(circulatorlowtemp_prop);
	//	Not Polled
	circulatorlowtemp->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(circulatorlowtemp);

	//	Attribute : circulatorHighTemp
	circulatorHighTempAttrib	*circulatorhightemp = new circulatorHighTempAttrib();
	Tango::UserDefaultAttrProp	circulatorhightemp_prop;
	//	description	not set for circulatorHighTemp
	//	label	not set for circulatorHighTemp
	//	unit	not set for circulatorHighTemp
	//	standard_unit	not set for circulatorHighTemp
	//	display_unit	not set for circulatorHighTemp
	//	format	not set for circulatorHighTemp
	//	max_value	not set for circulatorHighTemp
	//	min_value	not set for circulatorHighTemp
	//	max_alarm	not set for circulatorHighTemp
	//	min_alarm	not set for circulatorHighTemp
	//	max_warning	not set for circulatorHighTemp
	//	min_warning	not set for circulatorHighTemp
	//	delta_t	not set for circulatorHighTemp
	//	delta_val	not set for circulatorHighTemp
	circulatorhightemp->set_default_properties(circulatorhightemp_prop);
	//	Not Polled
	circulatorhightemp->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(circulatorhightemp);

	//	Attribute : vacuumFeedthroughFlow
	vacuumFeedthroughFlowAttrib	*vacuumfeedthroughflow = new vacuumFeedthroughFlowAttrib();
	Tango::UserDefaultAttrProp	vacuumfeedthroughflow_prop;
	//	description	not set for vacuumFeedthroughFlow
	//	label	not set for vacuumFeedthroughFlow
	//	unit	not set for vacuumFeedthroughFlow
	//	standard_unit	not set for vacuumFeedthroughFlow
	//	display_unit	not set for vacuumFeedthroughFlow
	//	format	not set for vacuumFeedthroughFlow
	//	max_value	not set for vacuumFeedthroughFlow
	//	min_value	not set for vacuumFeedthroughFlow
	//	max_alarm	not set for vacuumFeedthroughFlow
	//	min_alarm	not set for vacuumFeedthroughFlow
	//	max_warning	not set for vacuumFeedthroughFlow
	//	min_warning	not set for vacuumFeedthroughFlow
	//	delta_t	not set for vacuumFeedthroughFlow
	//	delta_val	not set for vacuumFeedthroughFlow
	vacuumfeedthroughflow->set_default_properties(vacuumfeedthroughflow_prop);
	//	Not Polled
	vacuumfeedthroughflow->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(vacuumfeedthroughflow);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(RfilkClass::attribute_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfilkClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : RfilkClass::pipe_factory()
 *	Description: Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void RfilkClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(RfilkClass::pipe_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfilkClass::pipe_factory_before
	/*----- PROTECTED REGION ID(RfilkClass::pipe_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfilkClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : RfilkClass::command_factory()
 *	Description: Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void RfilkClass::command_factory()
{
	/*----- PROTECTED REGION ID(RfilkClass::command_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfilkClass::command_factory_before


	//	Command ResetArcDetector
	ResetArcDetectorClass	*pResetArcDetectorCmd =
		new ResetArcDetectorClass("ResetArcDetector",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pResetArcDetectorCmd);

	/*----- PROTECTED REGION ID(RfilkClass::command_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfilkClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		RfilkClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the created attribute list
 */
//--------------------------------------------------------
void RfilkClass::create_static_attribute_list(std::vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		std::string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	TANGO_LOG_INFO << defaultAttList.size() << " attributes in default list" << std::endl;

	/*----- PROTECTED REGION ID(RfilkClass::create_static_att_list) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfilkClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		RfilkClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void RfilkClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, std::vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((std::string)(*devlist_ptr)[i]).c_str());
		Rfilk *dev = static_cast<Rfilk *> (dev_impl);

		std::vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		std::vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			std::string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			std::vector<std::string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				TANGO_LOG_INFO << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << std::endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(RfilkClass::erase_dynamic_attributes) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfilkClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method     : RfilkClass::get_attr_object_by_name()
 *	Description: returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *RfilkClass::get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname)
{
	std::vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(RfilkClass::Additional Methods) ENABLED START -----*/
/* clang-format on */
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfilkClass::Additional Methods
} //	namespace
