/*----- PROTECTED REGION ID(RfilkClass.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        RfilkClass.h
//
// description : Include for the Rfilk root class.
//               This class is the singleton class for
//                the Rfilk device class.
//               It contains all properties and methods which the
//               Rfilk requires only once e.g. the commands.
//
//
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef RfilkClass_H
#define RfilkClass_H

#include <tango.h>
#include "Rfilk.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfilkClass.h


namespace Rfilk_ns
{
/*----- PROTECTED REGION ID(RfilkClass::classes for dynamic creation) ENABLED START -----*/
/* clang-format on */

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfilkClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute cavityFlow class definition
class cavityFlowAttrib: public Tango::Attr
{
public:
	cavityFlowAttrib():Attr("cavityFlow",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~cavityFlowAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Rfilk *>(dev))->read_cavityFlow(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Rfilk *>(dev))->is_cavityFlow_allowed(ty);}
};

//	Attribute coolingRack class definition
class coolingRackAttrib: public Tango::Attr
{
public:
	coolingRackAttrib():Attr("coolingRack",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~coolingRackAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Rfilk *>(dev))->read_coolingRack(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Rfilk *>(dev))->is_coolingRack_allowed(ty);}
};

//	Attribute dummyLoadFlow class definition
class dummyLoadFlowAttrib: public Tango::Attr
{
public:
	dummyLoadFlowAttrib():Attr("dummyLoadFlow",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~dummyLoadFlowAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Rfilk *>(dev))->read_dummyLoadFlow(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Rfilk *>(dev))->is_dummyLoadFlow_allowed(ty);}
};

//	Attribute circulatorPs class definition
class circulatorPsAttrib: public Tango::Attr
{
public:
	circulatorPsAttrib():Attr("circulatorPs",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~circulatorPsAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Rfilk *>(dev))->read_circulatorPs(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Rfilk *>(dev))->is_circulatorPs_allowed(ty);}
};

//	Attribute circulatorArc class definition
class circulatorArcAttrib: public Tango::Attr
{
public:
	circulatorArcAttrib():Attr("circulatorArc",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~circulatorArcAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Rfilk *>(dev))->read_circulatorArc(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Rfilk *>(dev))->is_circulatorArc_allowed(ty);}
};

//	Attribute circulatorLowTemp class definition
class circulatorLowTempAttrib: public Tango::Attr
{
public:
	circulatorLowTempAttrib():Attr("circulatorLowTemp",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~circulatorLowTempAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Rfilk *>(dev))->read_circulatorLowTemp(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Rfilk *>(dev))->is_circulatorLowTemp_allowed(ty);}
};

//	Attribute circulatorHighTemp class definition
class circulatorHighTempAttrib: public Tango::Attr
{
public:
	circulatorHighTempAttrib():Attr("circulatorHighTemp",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~circulatorHighTempAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Rfilk *>(dev))->read_circulatorHighTemp(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Rfilk *>(dev))->is_circulatorHighTemp_allowed(ty);}
};

//	Attribute vacuumFeedthroughFlow class definition
class vacuumFeedthroughFlowAttrib: public Tango::Attr
{
public:
	vacuumFeedthroughFlowAttrib():Attr("vacuumFeedthroughFlow",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~vacuumFeedthroughFlowAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Rfilk *>(dev))->read_vacuumFeedthroughFlow(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Rfilk *>(dev))->is_vacuumFeedthroughFlow_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command ResetArcDetector class definition
class ResetArcDetectorClass : public Tango::Command
{
public:
	ResetArcDetectorClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	ResetArcDetectorClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~ResetArcDetectorClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Rfilk *>(dev))->is_ResetArcDetector_allowed(any);}
};


/**
 *	The RfilkClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  RfilkClass : public Tango::DeviceClass
#else
class RfilkClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(RfilkClass::Additional DServer data members) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfilkClass::Additional DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static RfilkClass *init(const char *);
		static RfilkClass *instance();
		~RfilkClass();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		RfilkClass(std::string &);
		static RfilkClass *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	Rfilk_H
