/*----- PROTECTED REGION ID(RfilkStateMachine.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        RfilkStateMachine.cpp
//
// description : State machine file for the Rfilk class
//
//
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include "Rfilk.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	Rfilk::RfilkStateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  ON       |  
//  OFF      |  
//  UNKNOWN  |  
//  FAULT    |  
//  ALARM    |  


namespace Rfilk_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : Rfilk::is_cavityFlow_allowed()
 *	Description: Execution allowed for cavityFlow attribute
 */
//--------------------------------------------------------
bool Rfilk::is_cavityFlow_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for cavityFlow attribute in read access.
	/*----- PROTECTED REGION ID(Rfilk::cavityFlowStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::cavityFlowStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : Rfilk::is_coolingRack_allowed()
 *	Description: Execution allowed for coolingRack attribute
 */
//--------------------------------------------------------
bool Rfilk::is_coolingRack_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Rfilk::coolingRackStateAllowed_READ) ENABLED START -----*/
		/* clang-format on */
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	Rfilk::coolingRackStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : Rfilk::is_dummyLoadFlow_allowed()
 *	Description: Execution allowed for dummyLoadFlow attribute
 */
//--------------------------------------------------------
bool Rfilk::is_dummyLoadFlow_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Rfilk::dummyLoadFlowStateAllowed_READ) ENABLED START -----*/
		/* clang-format on */
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	Rfilk::dummyLoadFlowStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : Rfilk::is_circulatorPs_allowed()
 *	Description: Execution allowed for circulatorPs attribute
 */
//--------------------------------------------------------
bool Rfilk::is_circulatorPs_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Rfilk::circulatorPsStateAllowed_READ) ENABLED START -----*/
		/* clang-format on */
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	Rfilk::circulatorPsStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : Rfilk::is_circulatorArc_allowed()
 *	Description: Execution allowed for circulatorArc attribute
 */
//--------------------------------------------------------
bool Rfilk::is_circulatorArc_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Rfilk::circulatorArcStateAllowed_READ) ENABLED START -----*/
		/* clang-format on */
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	Rfilk::circulatorArcStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : Rfilk::is_circulatorLowTemp_allowed()
 *	Description: Execution allowed for circulatorLowTemp attribute
 */
//--------------------------------------------------------
bool Rfilk::is_circulatorLowTemp_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Rfilk::circulatorLowTempStateAllowed_READ) ENABLED START -----*/
		/* clang-format on */
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	Rfilk::circulatorLowTempStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : Rfilk::is_circulatorHighTemp_allowed()
 *	Description: Execution allowed for circulatorHighTemp attribute
 */
//--------------------------------------------------------
bool Rfilk::is_circulatorHighTemp_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Rfilk::circulatorHighTempStateAllowed_READ) ENABLED START -----*/
		/* clang-format on */
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	Rfilk::circulatorHighTempStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : Rfilk::is_vacuumFeedthroughFlow_allowed()
 *	Description: Execution allowed for vacuumFeedthroughFlow attribute
 */
//--------------------------------------------------------
bool Rfilk::is_vacuumFeedthroughFlow_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(Rfilk::vacuumFeedthroughFlowStateAllowed_READ) ENABLED START -----*/
		/* clang-format on */
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	Rfilk::vacuumFeedthroughFlowStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : Rfilk::is_ResetArcDetector_allowed()
 *	Description: Execution allowed for ResetArcDetector attribute
 */
//--------------------------------------------------------
bool Rfilk::is_ResetArcDetector_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::UNKNOWN)
	{
	/*----- PROTECTED REGION ID(Rfilk::ResetArcDetectorStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Rfilk::ResetArcDetectorStateAllowed
		return false;
	}
	return true;
}


/*----- PROTECTED REGION ID(Rfilk::RfilkStateAllowed.AdditionalMethods) ENABLED START -----*/
/* clang-format on */
//	Additional Methods
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	Rfilk::RfilkStateAllowed.AdditionalMethods

}	//	End of namespace
